<?php
/**
 * Created by PhpStorm.
 * User: geovanesantos
 * Date: 18/11/2014
 * Time: 13:22
 */

namespace Gestao\Facade;

use Scheduler\Util\ReportParameterFunctions;

class EmbeddedReportFacade {
    public static function generateResultadosOperacionais(){

        $arrayParams=ReportParameterFunctions::buildParametersFromAmbiente();

        $filialList=tk_get_field_value("P_CDFILIAL");
        $supervisorList=tk_get_field_value("P_CDSUPERVISOR");
        $regionalList=tk_get_field_value("P_CDAREAGERE");

        $arrayParams['P_CDFILIAL']=ReportParameterFunctions::getInfoFromMultiSearchString($filialList, 'cdfilial');
        $arrayParams["P_CDAREAGERE"]=ReportParameterFunctions::getInfoFromMultiSearchString($regionalList, 'cdareagere');
        $arrayParams["P_CDSUPERVISOR"]=ReportParameterFunctions::getInfoFromMultiSearchString($supervisorList, 'cdoperador');

        $arrayParams["P_FLAGFILTER"]=tk_get_field_value("P_FLAGFILTER");

        //se o relatório agregar os dados em alguma dimensão, só aparecerá essa (se agregar tudo, não aparecerá nenhuma)
        //logo, não faz sentido permitir esconder alguma coluna quando se agrega (a opção nem aparecerá)
        $isAgg=tk_get_field_value("IS_AGG");
        if ($isAgg=='S'){
            $arrayParams["P_FLAGAGG"]=tk_get_field_value("TIPO_AGG");
            $arrayParams["P_HIDEREGIONAL"]='N';
            $arrayParams["P_HIDESUPERVISOR"]='N';
        }
        else{
            $arrayParams["P_FLAGAGG"]="N";
            $arrayParams["P_HIDEREGIONAL"]=tk_get_field_value("P_HIDEREGIONAL");
            $arrayParams["P_HIDESUPERVISOR"]=tk_get_field_value("P_HIDESUPERVISOR");
        }

        $dataString=tk_get_field_value("P_DATA");
        if (empty($dataString)){
            tk_abort("Por favor, selecione um mês.", 'info');
        }
        else{
            $data=\DateTime::createFromFormat("m/Y|", $dataString);
            $arrayParams["P_MES"]=$data->format("m");
            $arrayParams["P_ANO"]=$data->format("Y");
        }

        $nrgrupoString=tk_get_field_value("P_NRGRUPOREGRA");
        if (empty($nrgrupoString)){
            tk_abort("Por favor, selecione um Grupo de Regra.", 'info');
        }
        else{
            $arrayParams["P_NRGRUPOREGRA"]=$nrgrupoString;
        }

        //cada configuração de orientação é uma combinação de 3 opções no report
        $orientacao=tk_get_field_value("ORIENTACAO");
        if ($orientacao==="horizontal"){
            $arrayParams["ColumnDimension"]="Group";
            $arrayParams["RowDimension"]="Group1";
            $arrayParams["MeasureOrientation"]="false";
        }else {
            $arrayParams["ColumnDimension"]="Group1";
            $arrayParams["RowDimension"]="Group";
            $arrayParams["MeasureOrientation"]="true";
        }

        $menuTag=tk_get_env_var("MENU_NAME");
        tk_set_env_var($menuTag."_REPORT_PARAMS",$arrayParams);
        tk_set_env_var($menuTag."_REPORT_INPUT", Array("P_CDFILIAL"=>$filialList, "P_DATA"=>$dataString, "ORIENTACAO"=>$orientacao));
        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/GOP_DRO", $arrayParams);
        tk_close_window("ges_param_indicador_gop_dro", true);
    }

    public static function generateFiliaisNegativas(){
        $arrayParams=ReportParameterFunctions::buildParametersFromAmbiente();

        $filialList=tk_get_field_value("P_CDFILIAL");
        $supervisorList=tk_get_field_value("P_CDSUPERVISOR");
        $regionalList=tk_get_field_value("P_CDAREAGERE");

        $arrayParams['P_CDFILIAL']=ReportParameterFunctions::getInfoFromMultiSearchString($filialList, 'cdfilial');
        $arrayParams["P_CDAREAGERE"]=ReportParameterFunctions::getInfoFromMultiSearchString($regionalList, 'cdareagere');
        $arrayParams["P_CDSUPERVISOR"]=ReportParameterFunctions::getInfoFromMultiSearchString($supervisorList, 'cdoperador');

        $arrayParams["P_FLAGFILTER"]=tk_get_field_value("P_FLAGFILTER");
        $arrayParams["P_FLAGAGG"]=tk_get_field_value("P_FLAGAGG");

        $dataString=tk_get_field_value("P_DATA");
        if (empty($dataString)){
            tk_abort("Por favor, preencha o mês.", 'info');
        }
        else{
            $data=\DateTime::createFromFormat("m/Y|", $dataString);
            $arrayParams["P_MES"]=$data->format("m");
            $arrayParams["P_ANO"]=$data->format("Y");
        }

        $menuTag=tk_get_env_var("MENU_NAME");
        tk_set_env_var($menuTag."_REPORT_PARAMS",$arrayParams);
        tk_set_env_var($menuTag."_REPORT_INPUT", Array("P_CDFILIAL"=>$filialList, "P_DATA"=>$dataString));
        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/unidades_Negativas", $arrayParams);
        tk_close_window("ges_param_indicador_filiais_neg", true);
    }
//
//    public static function generateReportAsXLS()
//    {
//        $menuName=tk_get_menu_param(1);
//        $arrayParams=tk_get_env_var($menuName."_REPORT_PARAMS");
//        \View\Geral\Report\EmbeddedReportFacade::generateReport("/gestao/GOP_DRO", $arrayParams, "XLSX");
//    }
//
//    public static function reloadReport()
//    {
//        $toRun = tk_get_menu_param(0);
//        $menuName=tk_get_menu_param(1);
//        $isPopup = tk_get_menu_param(2);
//        \Scheduler\Facade\EmbeddedReportFacade::openPopupOrRunCallable($toRun, $isPopup);
//        if($isPopup) {
//            $inputParams = tk_get_env_var($menuName."_REPORT_INPUT");
////            tk_set_field_value("P_CDFILIAL", $inputParams["filial"], $toRun);
////            tk_set_field_value("P_DATA", $inputParams["data"], $toRun);
////            tk_set_field_value("ORIENTACAO", $inputParams["orientacao"], $toRun);
////            $fieldsToUpdate=Array($toRun.":".$toRun => Array( '-1' => Array(
////                "P_CDFILIAL" => $inputParams["filial"],
////                "P_DATA" => $inputParams["data"],
////                "ORIENTACAO" => $inputParams["orientacao"])));
//            $fieldsToUpdate=Array($toRun.":".$toRun => Array("-1"=>$inputParams));
//
//            Framework::getInstance()->setFieldsToUpdate($fieldsToUpdate);
//        }
//    }
//
//    public static function getInfoFromMultiSearchString($searchArray, $fieldName){
//
//        //Quando o multisearch está marcado como "Todos", ele retorna "A"
//        //Se retornar "A" (ou "N"), considera-se que não se quer filtrar,
//        //e o parâmetro de filial é setado como T (que o relatório entende como "todos")
//
//        if($searchArray!="A"&&$searchArray!="N"&&is_array($searchArray)){
//            //$searchArray é um array de arrays, e o que se deseja está no array de dentro
//            //é necessário iterar o array e pegar os códigos de lá
//            $returnArray=Array();
//            foreach($searchArray as $item){
//                $returnArray[]=$item[$fieldName];
//            }
//
//            $returnString=implode($returnArray,",");
//            //implode retorna false se receber um array vazio, mas precisa ser passado
//            //teoricamente o multisearch não poderia retornar um array vazio, isso é só pra garantir
//
//            if(!empty($returnString)){
//               return $returnString;
//            }
//            else{
//                return 'T';
//            }
//        }
//        else return 'T';
//
//    }

} 