/*******************************************************************************************************
  Nome
  7840_PLATRGO_GERA_HISTORICO_CARD.SQL

  Descrio
  GERAR HISTORICO PARA NO MOMENTO QUE O USUARIO ALTERAR UM CARDAPIO (TRANSFORM-LO EM ESPECIFICAO)
  O CAMPO ALTERADO IR REFLETIR NO RELATRIO DE HISTRIO DE ALTERACAO NO CARDPAIO

  Criao
  Alexis Tolentino de Moura

@C:\Web_411\Sql\End_Conv\Oracle\7840_PLATRGO_GERA_HISTORICO_CARD.sql
********************************************************************************************************/

CREATE OR REPLACE TRIGGER GERA_HISTORICO_CARD
BEFORE UPDATE ON COMPCARD FOR EACH ROW

DECLARE
   V_IDUTCARDPADR VARCHAR2(01);
   V_CDGRUPOPER   VARCHAR2(02);
   V_CDOPERADOR   VARCHAR2(12);
   V_CDOPERARDOR_ATUAL VARCHAR2(12);
   V_CLIENT_INFO varchar2(64);

BEGIN

   IF (:NEW.IDPRATOESPE = 'S') AND (:OLD.IDPRATOESPE <> 'S') AND (:OLD.CDPRATO <> :NEW.CDPRATO) THEN  /* GERAR HISTORICO APENAS QUANDDO A ALTERACAO FOR REFERENTE A PRATO ESPECIFICO */
      SELECT MAX(IDUTCARDPADR)
         INTO V_IDUTCARDPADR
      FROM PARAMGERAL
      WHERE CDPARGERAL = '0001';

      IF (V_IDUTCARDPADR = 'S') OR (V_IDUTCARDPADR = 'D') THEN    /* CARDAPIO LIVRE NAO IRA GERAR HISTORICO */

         SELECT MAX(CDGRUPOPER)
            INTO V_CDGRUPOPER
         FROM   AUTGRUPOP
         WHERE  IDAUTGRUPOP = 'LRCD';

         IF NOT (V_CDGRUPOPER IS NULL) THEN                       /* O GRUPO COM AUTORIZACAO TEM QUE ESTA PARAMETRIZADO */

            DBMS_APPLICATION_INFO.READ_CLIENT_INFO(V_CLIENT_INFO);
            V_CDOPERARDOR_ATUAL := SUBSTR(V_CLIENT_INFO, 1, 12);

            SELECT MAX(CDOPERADOR)
               INTO V_CDOPERADOR
            FROM
               OPERGRUPOP
            WHERE
               CDGRUPOPER = V_CDGRUPOPER AND
               CDOPERADOR = V_CDOPERARDOR_ATUAL;

            IF (V_CDOPERADOR IS NULL) THEN                    /* SE O OPERADOR NAO FIZER PARTE DO GRUPO PARAMETRIZADO */

               IF (:OLD.CDPRATOMAT IS NULL) THEN
                  :NEW.CDPRATOMAT      := :OLD.CDPRATO;
                  :NEW.CDFILAUXPRATMAT := :OLD.CDFILAUXPRAT;

                  :NEW.CDOPERALTE    := V_CDOPERARDOR_ATUAL;
                  :NEW.DTCOMPCARDALT := SYSDATE;
               END IF;

            END IF;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_HISTORICO_CARD','5.05.005'); END;
/

