/******************************************************************************/
/* AGENT2B                                                                    */
/*                                                                            */
/* Gesto Consolidada                                                         */
/******************************************************************************/
/*                                                                            */
/* Nome: ETL_RESULTDES                                                        */
/*                                                                            */
/* Criao:                                                                   */
/*    12/12/2006 - Fatima 						      */
/* Manuteno:								      */
/*    22/12/2006 - Raphael Ernani                                             */
/*                                                                            */
/*  @C:\WEB_411\Sql\End_Conv\Oracle\9322_GSCSTPO_ETL_RESULTDES.SQL            */
/******************************************************************************/
/* EXEC ETL_RESULTDES */
create or replace
PROCEDURE ETL_RESULTDES
                     (P_DTINI      IN DATE,
                      P_DTFINA     IN DATE)
IS
  V_DTFIM           DATE;
  V_DTINI           DATE;
  V_NRRESULTDES     ETLRESULTDES.NRRESULTDES%TYPE;
  V_DTMES           VARCHAR2(07);
  V_DTANO           VARCHAR2(04);
  V_TIPOFATU        VARCHAR2(30);
  V_BIM             VARCHAR2(02);
  V_TRI             VARCHAR2(02);
  V_SEM             varchar2(02);
  V_CLIENTE         VARCHAR2(21);
  V_QTTAREFA        VARCHAR2(20);
  V_QTAPROP         VARCHAR2(20);
  V_QTPLANE         VARCHAR2(20);
BEGIN
    BEGIN
      SELECT NVL(MAX(NRRESULTDES),0)
      INTO   V_NRRESULTDES
      FROM ETLRESULTDES;
      EXCEPTION
      WHEN OTHERS THEN
          V_NRRESULTDES := '0';
    END;
    V_DTMES  :=  TO_CHAR(P_DTINI,'MM');
    V_DTANO  :=  TO_CHAR(P_DTINI,'YYYY');
    BEGIN
       DELETE FROM ETLRESULTDES
       WHERE  ANRESULTDES >= V_DTANO
          AND MERESULTDES >= V_DTMES;
    END;
    V_DTFIM := LAST_DAY(V_DTINI);
    V_DTINI := P_DTINI;
    WHILE (V_DTINI  <=  P_DTFINA) LOOP
          V_DTFIM := LAST_DAY( V_DTINI);
          FOR C_ETL IN
              (SELECT 
                      P.CDOPERRESP, S.NRSOLISERV, P.CDPROCESSO, T.CDASSUNTO,
                      S.CDCLIENTE, FU.CDEQUIPETRAB, T.CDFILIAL,
                      T.NRTAREFA
               FROM   
                      APROATIVTARE A, PLANATIVTARE P, TAREFA T, SOLISERV S, 
                      PROCESSO PR, ASSUNTO AU, CLIENTE CL, OPERADOR OP, 
                      FUNCIONARIO FU
               WHERE  
                      A.CDFILIAL     = P.CDFILIAL
                  AND A.NRTAREFA     = P.NRTAREFA
                  AND A.NRPLATIVTARE = P.NRPLATIVTARE
                  AND P.CDOPERRESP   = OP.CDOPERADOR
                  AND P.CDFILIAL     = T.CDFILIAL
                  AND P.NRTAREFA     = T.NRTAREFA
                  AND T.CDFILIAL     = S.CDFILIAL(+)
                  AND T.NRSOLISERV   = S.NRSOLISERV(+)
                  AND T.CDPROCESSO   = PR.CDPROCESSO(+)
                  AND T.CDASSUNTO    = AU.CDASSUNTO
                  AND S.CDCLIENTE    = CL.CDCLIENTE(+)
                  AND OP.CDFUNC      = FU.CDFUNC
                  AND ((DTHIAPATIVTA BETWEEN V_DTINI AND V_DTFIM) 
                     OR(DTINPATIVTAR BETWEEN V_DTINI AND V_DTFIM)
                     OR(DTCONATIVTAR BETWEEN V_DTINI AND V_DTFIM))                  
              GROUP BY
                      P.CDOPERRESP, S.NRSOLISERV, P.CDPROCESSO, T.CDASSUNTO,
                      S.CDCLIENTE, FU.CDEQUIPETRAB, T.CDFILIAL,
                      T.NRTAREFA)              
          LOOP
          
              BEGIN
                 SELECT
                      COUNT(DISTINCT P.CDFILIAL||P.NRTAREFA||P.NRPLATIVTARE)
                 INTO 
                      V_QTTAREFA                 
                 FROM
                      TAREFA T, PLANATIVTARE P
                 WHERE
                      P.CDFILIAL       = T.CDFILIAL
                  AND P.NRTAREFA       = T.NRTAREFA
                  AND (P.CDFILIAL  (+) = C_ETL.CDFILIAL)
                  AND (T.NRSOLISERV(+) = C_ETL.NRSOLISERV)
                  AND (P.CDPROCESSO(+) = C_ETL.CDPROCESSO)
                  AND (T.CDASSUNTO (+) = C_ETL.CDASSUNTO)
                  AND (P.CDOPERRESP(+) = C_ETL.CDOPERRESP)
                  AND TRUNC(P.DTCONATIVTAR) BETWEEN V_DTINI AND V_DTFIM;
                  
                SELECT
                      SUM(TRUNC(TO_NUMBER(DTHFAPATIVTA - DTHIAPATIVTA)*60*24)),
                      SUM(TRUNC(TO_NUMBER(DTFIPATIVTAR - DTINPATIVTAR)*60*24))
                INTO
                      V_QTAPROP,
                      V_QTPLANE
                FROM
                      APROATIVTARE A,
                      PLANATIVTARE P
                WHERE  
                      A.CDFILIAL     = P.CDFILIAL
                  AND A.NRTAREFA     = P.NRTAREFA
                  AND A.NRPLATIVTARE = P.NRPLATIVTARE
                  AND P.CDOPERRESP   = C_ETL.CDOPERRESP
                  AND P.CDFILIAL     = C_ETL.CDFILIAL
                  AND P.NRTAREFA     = C_ETL.NRTAREFA
                  AND ((DTHIAPATIVTA BETWEEN V_DTINI AND V_DTFIM) 
                     OR(DTINPATIVTAR BETWEEN V_DTINI AND V_DTFIM));
              END;
              
              V_DTMES  :=  TO_CHAR(V_DTFIM,'MM');
              V_DTANO  :=  TO_CHAR(V_DTFIM,'YYYY');
              V_BIM := TRUNC ((V_DTMES - 1) / 2) + 1;
              V_TRI := TRUNC ((V_DTMES - 1) / 3) + 1;
              V_SEM := TRUNC ((V_DTMES - 1) / 6) + 1;
              V_CLIENTE := C_ETL.CDCLIENTE;
              IF C_ETL.CDCLIENTE IS NULL THEN
                 V_CLIENTE := 'J26269316000177';
              END IF;
              V_NRRESULTDES := V_NRRESULTDES + 1;
              INSERT INTO ETLRESULTDES
                   (NRRESULTDES, CDOPERADOR, NRSOLISERV, CDPROCESSO, CDASSUNTO, CDCLIENTE,
                   CDEQUIPETRAB, ANRESULTDES, MERESULTDES, BIRESULTDES,
                   TRRESULTDES, SERESULTDES, QTHRAPRESDES, QTHRPlRESDES, QTTARERESDES)
              VALUES
                    (V_NRRESULTDES, C_ETL.CDOPERRESP, C_ETL.NRSOLISERV, C_ETL.CDPROCESSO, C_ETL.CDASSUNTO, C_ETL.CDCLIENTE,
                    C_ETL.CDEQUIPETRAB, V_DTANO, V_DTMES, (V_BIM || ' Bim'),
                    (V_TRI || ' TRI'), ( V_SEM || ' Sem'),  V_QTAPROP, V_QTPLANE, V_QTTAREFA);
          END LOOP;
          COMMIT;
          V_DTINI := ADD_MONTHS(V_DTINI,1);
    END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_RESULTDES','5.07.008'); END;
/

